<?php
include "fefunctions.php";
include "iocommand.php";
error_reporting(E_ALL ^ E_WARNING ^ E_NOTICE);
start_session();

   /***********************************************************************
   *    Copyright � 2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

$_SESSION["page"] = "quick.php";
$_SESSION["comparing"] = "0";

$bgcolor = "#ffffff";
?>
<html>
  <head>
    <meta http-equiv='content-type' content='text/html; charset=UTF-8'>
    <title>HP Insight Diagnostics</title>
    <link rel='stylesheet' type='text/css' href='stylesheets/main.css'>
    <link rel='stylesheet' type='text/css' href='stylesheets/header.css'>
    <style> body { background:white; } </style>
    <SCRIPT LANGUAGE='JavaScript' SRC='menufunctions.js'></SCRIPT>
    <SCRIPT LANGUAGE='JavaScript' SRC='dom-drag.js'></SCRIPT>
    <script language="Javascript">
      function initPage()
      {
        theScheduleTitle = document.getElementById("scheduleTitle");
        theSchedule   = document.getElementById("scheduleIt");
        Drag.init(theScheduleTitle, theSchedule);        
        /*
	      theaboutHandle = document.getElementById("abouthandleIt");
	      theaboutRoot   = document.getElementById("aboutrootIt");
	      Drag.init(theaboutHandle, theaboutRoot);        
          */
          
          top.frames.dataFrame1.enableTabs();
          top.frames.dataFrame2.enableTestSubTabs();
      }
    </script>
  </head>
<?php
  $ossmp = "";
  $test = 0;
  $test = $_REQUEST["send"];
  
  if ($_REQUEST["testMode"] != "")
    $_SESSION["testMode"] = $_REQUEST["testMode"];

  if ($_REQUEST["runMode"] != "")
    $_SESSION["runMode"] = $_REQUEST["runMode"];

  $testFilter = "[@quick='1' and @fieldtest='1'";
  if ($_SESSION["testMode"] == "unattended")
    $testFilter = $testFilter . " and @interactive='0'";

  $packageTestFilter = $testFilter . " and (../@component!='cdm' or @package='1')]";
  $testFilter = $testFilter . "]";

  if ($test) // if tests have been submitted
  {
    printf("<body>");
	  $deviceName = $_REQUEST["deviceSelection"];
	  $stopOnError = $_REQUEST["stopOnError"];
	  $runMode = $_REQUEST["runMode"];

	  if ($runMode == "time")
	    $test = $_REQUEST["totalTestTime"];
	  else
	    $test = $_REQUEST["testLoops"];

	  $dom = domxml_new_doc("1.0");
	  $startProcess = $dom->create_element("startProcess");
	  $diagRun = $dom->create_element("diagRun");

    $diagRun->set_attribute("jobCaption", htmlentities(TR("MSG_QUICK_TEST"),ENT_QUOTES,'utf-8'));

	  if ($runMode == "time")
	    $diagRun->set_attribute("desiredTestTime", $test);
	  else
	    $diagRun->set_attribute("testLoops", $test);

    if ($stopOnError == "on")
      $diagRun->set_attribute("stopOnError", "1");
    
    $diagRun->set_attribute("language", GetLanguage());        

    $deviceXpathStr = "/diagOutput/category/device";
    if ($deviceName != "allDevices")
      $deviceXpathStr = $deviceXpathStr . "[@name='". $deviceName . "']";

    $idXml = new DomDocument($_SESSION["idResult"]);
    $idXpath = @xpath_new_context($idXml->document_element());
    $devices = @xpath_eval($idXpath, $deviceXpathStr);
    $num_devices = count($devices->nodeset);
    for ($i=0; $i < $num_devices; $i++)
    {
      $deviceNode = $devices->nodeset[$i];
      $deviceXpath = @xpath_new_context($deviceNode);
      $tests = @xpath_eval($deviceXpath, "/test".$packageTestFilter);
      if (count($tests->nodeset) == 0)
        $tests = @xpath_eval($deviceXpath, "/test".$testFilter);
      // iterate through tests
      $num_tests = count($tests->nodeset);
      for ($k=0; $k < $num_tests; $k++)
      {
        $testNode = $tests->nodeset[$k];
        $testParent = $testNode->parent_node();
        $testName = $testNode->get_attribute("name");
        $testDescription = $testNode->get_attribute("description");
        $testCaption = $testNode->get_attribute("caption");
        $deviceCaption = $testParent->get_attribute("caption");
        $componentName = $testParent->get_attribute("component");
        $cdmClass = $testParent->get_attribute("cdmClass");              
        $deviceSlot = $testParent->get_attribute("Slot");
        if ($componentName == "cdm")
          $deviceName = $testParent->get_attribute("deviceID");
        else
          $deviceName = $testParent->get_attribute("name");              

        $runTest = $dom->create_element("runTest");
        $runTest->set_attribute("component", $componentName);

        if ($componentName == "cdm")
        {
          $runTest->set_attribute("cdmClass", $cdmClass);
        }

        $tcLoadFilename = $componentName . ".dat";
        $runTest->set_attribute("tcLoadFilename", $tcLoadFilename);
        $runTest->set_attribute("language", GetLanguage());
        $runTest->set_attribute("device", $deviceName);
        $runTest->set_attribute("test", $testName);
        if ($deviceSlot != "")
          $runTest->set_attribute("Slot", $deviceSlot); // slot the ctrlr is in that the device is attached to
        $runTest->set_attribute("description", htmlentities($testDescription,ENT_QUOTES,'utf-8'));
        $runTest->set_attribute("caption", htmlentities($deviceCaption . " - " . $testCaption,ENT_QUOTES,'utf-8'));
        if ($testNode->get_attribute("singleThread") == "1")
          $runTest->set_attribute("singleThread", "1");
        if ($testNode->get_attribute("interactive") == "1" && $_SESSION["testMode"] == "interactive")
          $runTest->set_attribute("interactive", "1");

        $runTest->set_attribute("quick", "1");

        $diagRun->append_child($runTest);
      }
    }

    $scheduleMode = $HTTP_POST_VARS["scheduleType"];
  
    if ($scheduleMode == "diagRun") // if we want to schedule this test
    { 
      $scheduleProcess = $dom->create_element("scheduleProcess");
      $scheduleProcess->set_attribute("hour", $HTTP_POST_VARS["scheduleHour"]);
      $scheduleProcess->set_attribute("minute", $HTTP_POST_VARS["scheduleMinute"]);
      $scheduleProcess->set_attribute("mode", $HTTP_POST_VARS["scheduleMode"]);
      $scheduleProcess->set_attribute("weekdays", $HTTP_POST_VARS["scheduleWeekdays"]);
      $scheduleProcess->set_attribute("months", $HTTP_POST_VARS["scheduleMonths"]);
      $scheduleProcess->set_attribute("monthdays",$HTTP_POST_VARS["scheduleMonthdays"]);
      $scheduleProcess->append_child($diagRun);
      $dom->append_child($scheduleProcess);
    }
    else // otherwise, run now
    {
      $startProcess->append_child($diagRun);
      $dom->append_child($startProcess);
    }

	  // debug - display diagRun xml to web page
    //echo htmlentities($dom->html_dump_mem());

  	// Submit the diagRun command					  
    $runErrors = "";
    $runStatus = "";
    if (GetLanguage() == "ja")
      $diagRunStr = sprintf("%s", $dom->dump_mem(true, "UTF-8"));
    else
      $diagRunStr = sprintf("%s", $dom->dump_mem());
    $_SESSION["diagRun"] = $diagRunStr;
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $diagRunStr, $runStatus, $runErrors);
    $xmldoc = new DomDocument($runStatus);

    $_SESSION["statusxml"] = "";
    $_SESSION["lastLoop"] = "";
    $_SESSION["promptID"] = "";
    $_SESSION["statusDrawn"] = "false";
    unset($_SESSION["completedTests"]);
    $_SESSION["prompting"] = false;
    $_SESSION["diagnosisResult"] = "";

    $rootElement = $xmldoc->document_element();
    $_SESSION["testpid"] = $rootElement->get_attribute("processID");
	 	
    if ($scheduleMode != "diagRun") // if we did not schedule this test
    {
      // GO TO STATUS PAGE NOW...
      printf("<script language=\"JavaScript\">\n");
      /*
      if (IsDiagsCD() || IsPhoenix())
      {
        //remove the refresh button - it will lock up if we try to refresh whne testing
        printf("parent.parent.frames.headerFrame.document.getElementById('refresh').style.visibility = 'hidden';\n");
        printf("parent.parent.frames.headerFrame.document.getElementById('refresh').style.display = 'none';\n");
      }
      */
      //printf("parent.parent.frames.headerFrame.scheduledTest = '';\n");
      printf("parent.frames.dataFrame1.doTab(3);\n");
      printf("parent.frames.dataFrame2.location = 'statusheader.php';");
      printf("</script>\n");
    }
    else
    {
      // GO TO STATUS PAGE NOW...
      printf("<script language=\"JavaScript\">\n");
      printf("parent.parent.frames.headerFrame.scheduledTest = 'quick';\n");
      printf("location = 'quick.php';\n");
      printf("</script>\n");
    }
  }
  else // build the test page
  {
?>





  <body TOPMARGIN=0 MARGINHEIGHT=0 onload='initPage();'>
  <?php
  CreateAboutDiv();
  ?>

    <FORM name='diagRunForm' method=post> 
      <table border=0 cellspacing=0 cellpadding=0 width='100%' height=100% bgcolor=white>
        <tr>
          <td width=5>
          </td>
          <td valign=top>
<?php


    $idXml = new DomDocument($_SESSION["idResult"]);
    $idXpath = @xpath_new_context($idXml->document_element());
    $devices = @xpath_eval($idXpath, "/diagOutput/category/device");

    $ci = new client_info();
    printf("<table width=100%%");
    if (strstr($ci->get_client_platform(), "indows"))
    {
      if (strstr($ci->get_client_browser(), "IE"))
        printf(" height='420'");
      else
        printf(" height='431'");
    }
    else
    {
      if (IsPhoenix())
        printf(" height='94%%'");
      else
        printf(" height='94%%'");
    }
    printf(" border=0 cellspacing=0 cellpadding=0>\n");
    printf("<tr>\n<td width=6 bgcolor=#cccccc></td><td colspan=2 valign=top>");    

    printf("<table>\n");
    printf("<tr>\n<td width=5></td>    <td colspan=2>\n");
    printf("      %s<br>\n", TR('MSG_SELECT_DEVICE_QUICK'));
    printf("      %s\n", TR('MSG_SELECT_ALL_DEVICES_QUICK'));
    if (IsOnline())
      printf("      <br>%s", TR("MSG_TEST_SCHEDULE_INSTRUCTION"));
    printf("	</td>\n  </tr>\n");
    
    printf("  <tr><td width=5></td><td colspan=2>%s: <input type=radio name='testMode' value='interactive' onclick=\"document.diagRunForm.submit();\"", TR("MSG_TEST_MODE"));
    if ($_SESSION["testMode"] == "interactive")
      printf(" checked");
    printf(">%s <input type='radio' name='testMode' value='unattended' onclick=\"document.diagRunForm.submit();\"", TR("MSG_INTERACTIVE"));
    if ($_SESSION["testMode"] != "interactive")
      printf(" checked");
    printf(">%s</td></tr>", TR("MSG_UNATTENDED"));
    printf("  <tr><td width=5></td><td colspan=2>%s: <input type=radio id='runModeLoops' name='runMode' value='loops'", TR("MSG_DURATION_OF_TEST"));
    if ($_SESSION["runMode"] != "time")
      printF(" checked");
    printf(">%s <input type=text size=4 maxlength=4 id=testLoopsId name=testLoops VALUE='1'> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type='radio' id='runModeTime' name='runMode' value='time'", TR("MSG_NUMBER_OF_LOOPS"));
    if ($_SESSION["runMode"] == "time")
      printf(" checked");
    printf(">%s <input type=text size=4 maxlength=4 id=totalTestTimeId name=totalTestTime VALUE='0'></td></tr>", TR("MSG_TOTAL_TEST_TIME"));
    printf("  <tr><td width=5></td><td colspan=2><input type='checkbox' name='stopOnError'>%s</td>\n</tr>", TR("MSG_STOP_ON_FIRST_ERROR"));
    printf("  <tr valign=top>\n<td width=5></td>");
    printf("    <td colspan=2>%s:</td>\n", TR("MSG_SELECT_DEVICE"));
    printf("  </tr>\n");
    printf("  <tr valign=top>\n<td width=5></td>");
    printf("    <td colspan=2>\n");
    printf("      <SELECT NAME='deviceSelection' onChange='hideScheduledMessage();'>\n");
    printf("        <OPTION VALUE='allDevices' SELECTED>%s</OPTION>\n", TR("MSG_ALL_DEVICES"));

    $num_devices = count($devices->nodeset);
    $num_tests = 0;
    for ($i=0; $i < $num_devices; $i++)
    {
      $deviceNode = $devices->nodeset[$i];
      $deviceXpath = @xpath_new_context($deviceNode);
	    $tests = @xpath_eval($deviceXpath, "/test".$packageTestFilter);
      if (count($tests->nodeset) == 0)
        $tests = @xpath_eval($deviceXpath, "/test".$testFilter);
      $num_tests = count($tests->nodeset);
      if ($num_tests)
      {	
        $deviceName = $deviceNode->get_attribute("name");
        $deviceCaption = $deviceNode->get_attribute("caption");
        $deviceDescription = $deviceNode->get_attribute("description");
        $listWithoutTests = $deviceNode->get_attribute("listWithoutTests");
        $mediaTests = @xpath_eval($deviceXpath, "/test[@requiresMedia='1']");          
        if ($listWithoutTests == "1")
        {
          $deviceDescription = $deviceNode->get_attribute("listWithoutTestsCaption");
          $ossmp = $ossmp . sprintf("mediaArray[%s] = new Array('%s','LWOT');\n", $i+1, $deviceName, $deviceCaption);
        }
        else if (count($mediaTests->nodeset))
          $ossmp = $ossmp . sprintf("mediaArray[%s] = new Array('%s','%s');\n", $i+1, $deviceName, $deviceCaption);
        else
          $ossmp = $ossmp . sprintf("mediaArray[%s] = new Array('FALSE','%s');\n", $i+1, $deviceName, $deviceCaption);
        
        printf("        <OPTION VALUE='%s'>%s: %s</OPTION>\n", $deviceName, $deviceCaption, $deviceDescription);
         
	    }
      else
        $ossmp = $ossmp . sprintf("mediaArray[%s] = new Array('FALSE','FALSE');\n", $i+1);
    }

    printf("      </SELECT><br>\n    </td>\n  </tr>\n");
    printf("<tr><td colspan=3></td></tr>");
    printf("</table>\n");

    printf("</td>\n<td width=5 bgcolor=white></td>\n<td bgcolor=#cccccc width=5></td>\n</tr>\n");
    printf("<tr><td bgcolor=#cccccc height=5></td><td width=5 colspan=3></td><td bgcolor=#cccccc width=5></td></tr>\n");
    printf("<tr><td bgcolor=#cccccc width=5 colspan=5 height=5></td></tr>\n");
    printf("<tr><td colspan=5 height=5></td></tr>\n");
    //printf("<tr><td colspan=5 height=10>\n");                                                                                                                                                           
    if (!IsOnline() || IsFactory())
      printf("<table border=0 width=100%%>\n<tr>\n<td width=60%%>%s</td><td align=right>%s</td>", MakeButton(TR("MSG_EXIT") ." ". TR("MSG_DIAGNOSTICS"), "parent.frames.headerFrame.exit();"), MakeButton(TR("MSG_BEGIN_TESTING"), "BeginTesting();"));
    else
      printf("<table border=0 width=100%%>\n<tr>\n<td width=60%%>&nbsp;</td><td align=right>%s</td>", MakeButton(TR("MSG_BEGIN_TESTING"), "BeginTesting();"));
    if (!IsPhoenix())
      printf("<td align=right>%s</td>\n", MakeButton(TR("MSG_SCHEDULED_QUICK_TESTS"),"document.getElementById('scheduleIt').style.display = 'inline';document.getElementById('scheduleIt').style.visibility = 'visible';"));
    printf("</tr>\n</table>\n\n");
printf("</td></tr>");
printf("</table>");
?>

	  <input type='hidden' name='send' value='0'>
	  <input type='hidden' name='scheduleType' value='1'>
    <input type='hidden' name='scheduleHour' value=''/>
    <input type='hidden' name='scheduleMinute' value=''/>
    <input type='hidden' name='scheduleMode' value=''/>
    <input type='hidden' name='scheduleWeekdays' value=''/>
    <input type='hidden' name='scheduleMonths' value=''/>
    <input type='hidden' name='scheduleMonthdays' value=''/>

    <script language='Javascript'>
    var mediaArray = new Array();
<?php
    printf("mediaArray[0] = new Array('allDevices','%s');\n", TR("MSG_ALL_DEVICES"));
    printf("%s\n", $ossmp);
?>
    function BeginTesting()
    {
     if(((isNaN(document.getElementById("totalTestTimeId").value)||document.getElementById("totalTestTimeId").value<=0) && document.getElementById("runModeTime").checked)
       ||((isNaN(document.getElementById("testLoopsId").value) || document.getElementById("testLoopsId").value<=0) && document.getElementById("runModeLoops").checked))
     {
        alert("<?php echo TR('MSG_LOOP_NUMBER_AND_TEST_TIME_BIGGER_THAN_ZERO'); ?>");
        //alert("Number of loops or total test time entered must be greater than zero");
     }
     else
     {

      for (var i=0; i <= <?php echo $num_devices;?>; i++)
      {
        if ((document.diagRunForm.deviceSelection.value == mediaArray[i][0]) && (mediaArray[i][1] == "LWOT"))
        {
          <?php printf("alert(\"%s\");\n", TR("MSG_DEVICE_IN_USE")); ?>
          return;
        }
        else if (document.diagRunForm.deviceSelection.value == mediaArray[i][0])
        {
          <?php printf("alert(\"%s \" + mediaArray[i][1]);\n", TR("MSG_PLEASE_INSERT_MEDIA")); ?>
          break;
        }
      }
      document.diagRunForm.send.value=1;
      document.diagRunForm.submit();
     }
    }
    
    /*
    if(parent.parent.frames.headerFrame.scheduledTest == "quick")
    {
      showScheduledMessage();
    }
    */
    parent.frames.globalFrame.testPage = "quick.php";
    </script>

    <input type='hidden' name='testSubmit' value='1'>

</form>
<?php
include "schedule.php";

  }

?>
<script language="Javascript" src="norightclick.js"></script></body></html>





