<?php
  header('Content-type: text/plain', true);

  include_once '../includes/globals.php';
  include_once '../includes/rosetta.class.php';

  $xml = new DomDocument(file_get_contents(IDRESULT_PATH));
  if (!$xml)
  {
    $outputArray = array(
      'name'  => 'XML Error',
      'value' => $stdout);
    die(Rosetta::arrayToJSON($outputArray));
  }

  $diagnosableDevices = array();
  $xpath = xpath_new_context($xml->document_element());
  $devices = @ xpath_eval($xpath, '/diagOutput/category/device[@diagnosable="1"]');
  foreach ($devices->nodeset as $device)
  {
    $deviceArray = array();
    $deviceArray['name'] = $device->get_attribute('name');
    $deviceArray['caption'] = $device->get_attribute('caption');
    $diagnosableDevices[] = $deviceArray;
  }

  // Output JSON object
  exit(Rosetta::arrayToJSON($diagnosableDevices));
  //*/
?>
